import win32.windows;
import std.string;
import std.utf;
import std.stdio;
import win32frame.writek;


class WindowMenu {
  HMENU  hrootmenu ;
  HMENU  hsubmenu[string] ;
  MENUITEMINFO mii;
  
  this() {
    mii.cbSize  = MENUITEMINFO.sizeof ;
  }

  int create(){
    this.hrootmenu=CreateMenu() ;
    if( this.hrootmenu==null ) return(-1) ;
    return(0)  ;
  }

  int addMenu( UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      if( (item in this.hsubmenu)==null ){
    	this.hsubmenu[item]=CreateMenu() ;
    	if( (item in this.hsubmenu)!=null ){
	  mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
	  mii.fType   = type ;
	  mii.hSubMenu= hsubmenu[item] ;
	  mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
	  InsertMenuItem(hrootmenu, id, FALSE , &mii) ;
    	}
      }
      return(0) ;
    }
    return(-1) ;
  }    

  int addMenu( string name, UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      if( (item in this.hsubmenu)==null ){
	this.hsubmenu[item]=CreateMenu() ;
	if( (item in this.hsubmenu)!=null ){
	  mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
	  mii.fType   = type ;
	  mii.hSubMenu= hsubmenu[item] ;
	  mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
	  InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
	}
      }
      return(0) ;
    }
    return(-1) ;
  }    

  int addItem( string name, UINT type, string item, int id ) {
    if( this.hrootmenu!=null ){
      mii.fMask   = MIIM_TYPE|MIIM_ID ;
      mii.fType   = type ;
      mii.hSubMenu= hsubmenu[name] ;
      mii.wID     = id ;
      mii.dwTypeData = toUTFz!(LPWSTR)(item) ;
      InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
      return(0) ;
    }
    return(-1) ;
  }

  int deleteItem( int id ) {
    int res ;
    if( this.hrootmenu!=null ){
      res=DeleteMenu( this.hrootmenu, id, MF_BYCOMMAND ) ;
      if( res!=0 ){
	return(0) ;
      }
    }
    return(-1) ;
  }

  int deleteItem( string name, int id ) {
    int res ;
    if( this.hrootmenu!=null ){
      res=DeleteMenu( hsubmenu[name], id, MF_BYCOMMAND ) ;
      if( res!=0 ){
	return(0) ;
      }
    }
    return(-1) ;
  }

  HMENU getHMENU(){
    writek("getHMENU=%08x\n",cast(int)(hrootmenu)) ;
    if( this.hrootmenu!=null ){
      return(this.hrootmenu) ;
    }
    return(null) ;
  }

}
